/*
 * JBoss, Home of Professional Open Source
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.cmp2.batchcascadedelete.ejb;

import java.rmi.RemoteException;
import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;
import javax.ejb.RemoveException;
import javax.naming.NamingException;

/**
 * @author <a href="mailto:alex@jboss.org">Alexey Loubyansky</a>
 * @version <tt>$Revision: 1.1.2.1 $</tt>
 */
public abstract class ChildBean
   implements EntityBean
{

   public Long ejbCreate(Parent parent, String name) throws CreateException
   {
      setId(new Long(System.currentTimeMillis()));
      setName(name);

      return null;
   }

   public void ejbPostCreate(Parent parent, String name) throws CreateException
   {
      ParentLocalHome h;
      try
      {
         h = ParentUtil.getLocalHome();
         setTheParent(h.findByPrimaryKey(parent.getId()));
         setParentId(parent.getId().longValue());
      }
      catch(NamingException e)
      {
         throw new CreateException(e.toString());
      }
      catch(RemoteException e)
      {
         throw new CreateException(e.toString());
      }
      catch(FinderException e)
      {
         throw new CreateException(e.toString());
      }
   }

   public abstract Long getId();

   public abstract void setId(Long id);

   public abstract long getParentId();

   public abstract void setParentId(long parentId);

   public abstract String getName();

   public abstract void setName(String name);

   public ChildBean()
   {
      super();
   }

   public abstract ParentLocal getTheParent();

   public abstract void setTheParent(ParentLocal theParent);


   public void setEntityContext(EntityContext arg0) throws EJBException, RemoteException
   {
   }

   public void unsetEntityContext() throws EJBException, RemoteException
   {
   }

   public void ejbRemove() throws RemoveException, EJBException, RemoteException
   {
   }

   public void ejbActivate() throws EJBException, RemoteException
   {
   }

   public void ejbPassivate() throws EJBException, RemoteException
   {
   }

   public void ejbLoad() throws EJBException, RemoteException
   {
   }

   public void ejbStore() throws EJBException, RemoteException
   {
   }
}
